C     Last change:  GSL  11 Jan 2010   11:25 am
c 
c     Program to predict flow-duration and low-flow discharges
c     for unregulated streams in Tennessee.
c     TASKER-LAW 2005-09.
      character*80 vout, site 
      character*10 zlab(4)
      real dist(1050),v(1050,6),sesav(4,17),
     + q(1050,17),sd(4),pv4(4,17),tbeta(4,17),bsav(4,17)
      real mxt,myt,a,b,xL,sumx,sumy,sumxx,sumyy,sumxy
      real xv(50,10),xvt(10,50),xtxinv(10,10),xtx(10,10),bhat(10,1)
      real yv(50,1),e(50,1),work(10,50),work2(1,10),xo(10,1)
      real xot(1,10), hat(1,1)
      REAL ey,sums,asig2,eybing
      REAL tv4,ptest,STUTP
      INTEGER ne,ndf,jreg,Nsites,jpeak,ksav,nexp(17),kdrop(2)
      real area,gf,gfc,cf,sf,uss,probz7,probz30,probzd,pru,cl90,cu90
      REAL pruz7,predz7,cl90z7,cu90z7,pruz30,predz30,cl90z30,cu90z30
      REAL pruzd,predzd,cl90zd,cu90zd
      real altm,alts,altd,alnd,alnm,alns
      real logsf,logda,logcf,loggf,lgf30,loguss
      integer id(1050),indx(1050),jvar(1050,17),ireg(1050) 
      INTEGER ltd, ltm, lts, lnd, lnm, lns
      CHARACTER*2 Alab(2)
      character*8 Pklab(17)
      character*80 name(1050)
      PRINT *, ' This program estimates selected low-flow and          '
      PRINT *, ' flow-duration discharges for unregulated streams      '
      PRINT *, ' using: (1) Region-of-Influence (ROI) method, and      '
      PRINT *, '        (2) Regional-regression (RRE) equations.       '
      PRINT *, '                                                       '
      PRINT *, ' N(ROI,W) =  45 VARIABLE SITES, WEST TENN REGION,      '
      PRINT *, ' N(ROI,CE)=  45 VARIABLE SITES, CENTRAL+EAST TENN REG.,'
      PRINT *, ' N(RRE,W) = 124 CONSTANT SITES, WEST TENN REGION,      '
      PRINT *, ' N(RRE,CE)= 891 CONSTANT SITES, CENTRAL+EAST TENN REG. '
      PRINT *, '                                                       '
      PRINT *, ' Use USGS StreamStats program to compute watershed     '
      PRINT *, ' characteristics for manual entry to this program.     '
      PRINT *, ' http://water.usgs.gov/osw/streamstats/index.html      '
      PRINT *, '                                                       '
      PRINT *, ' REFERENCE: "Streamflow Characteristic Estimation      '
      PRINT *, ' Methods for Unregulated Streams of Tennessee"         '
      PRINT *, ' by George S. Law, Gary D. Tasker, and David E. Ladd.  '
      PRINT *, ' [USGS Scientific Investigations Report 09-5159]       '
      PRINT *, '-------------------------------------------------------'
      PRINT *, '* No warranty, expressed or implied, is made by USGS  *'
      PRINT *, '* for accuracy and functioning of program and related *'
      PRINT *, '* program material. [TDEC Version 3.0.1 -- 28FEB2009] *'
      PRINT *, '-------------------------------------------------------'
      PRINT *, ' Output will be to a user named output file.           '
      PRINT *, ' ENTER name of output file: '
      READ (*,9005) vout 
 9005 FORMAT(A80) 
      OPEN (16,file=vout) 
   10 CONTINUE
      PRINT *, ' Is site in West or Central+East Region of Tennessee?'
      PRINT *, '  '
      PRINT *, ' ENTER 1 for West Region'
      print *, ' ENTER 0 for Central+East Region'
      PRINT *, ' : '
      READ(*,*)jreg
      IF(jreg.eq.1)then
      open(10,file='DATWv303.txt')
      open(11,file='NAMWv203.txt')
      end if
      IF(jreg.eq.0)then
      open(10,file='DATMv303.txt')
      open(11,file='NAMMv203.txt')
      end if
      PRINT *, ' ENTER name for site'
      PRINT *, ' : '
      READ (*,9005) Site
      PRINT *, ' ENTER site latitude (dd mm ss): '
      READ (*,*) altd, altm, alts
      PRINT *, ' ENTER site longitude as a positive no. (dd mm ss): '
      READ (*,*) alnd, alnm, alns
      ltd=altd
      ltm=altm
      lts=alts
      lnd=alnd
      lnm=alnm
      lns=alns
      PRINT *, ' ENTER watershed characteristics for site'
      PRINT *, '      '
      PRINT *, ' Drainage area in square miles,'
      PRINT *, ' recommended range by region-- '
      print *, ' West        : 1.00 to  2,400 '
      PRINT *, ' Central+East: 1.00 to 10,000 '
      PRINT *, ' : '
      READ (*,*) Area
      PRINT *, ' Geology Factor as a whole number,'
      PRINT *, ' required range by region--  '
      PRINT *, ' West        :   32 to 350 '
      PRINT *, ' Central+East:   32 to 175 '
      PRINT *, ' : '
      READ (*,*) GF
      PRINT *, ' Climate Factor with 3 decimal places,'
      PRINT *, ' required range by region--  '
      PRINT *, ' West        : 2.307 to 2.455 '
      PRINT *, ' Central+East: 2.056 to 2.461 '
      PRINT *, ' : '
      READ (*,*) CF
      PRINT *, ' Soil Factor as a whole number, '
      PRINT *, ' required range by region--  '
      PRINT *, ' West        :  2 to  98 '
      PRINT *, ' Central+East:  2 to 100 '
      PRINT *, ' : '
      READ (*,*) SF
      IF(jreg.eq.1)then
        IF(sf.lt.32)THEN sf=32
      END if
      PRINT *, ' Soil permeability with 2 decimal places,'
      PRINT *, ' required range by region--  '
      PRINT *, ' West        : 0.97 to 2.44 '
      PRINT *, ' Central+East: 0.45 to 9.72 '
      PRINT *, ' : '
      READ (*,*) USS
      logda=alog10(AREA)
      loggf=alog10(GF)
      lgf30=alog10(GF-30.0)
      logsf=alog10(SF)
      lsf30=alog10(SF-30.0)
      logcf=alog10(CF)
      loguss=alog10(USS)
      ptest=1.0
      Alab(1)=' N'
      Alab(2)=' Y'
      Pklab(1)='  7Q10  '
      Pklab(2)='  30Q5  '
      Pklab(3)='   MA   '
      Pklab(4)='   MS   '
      Pklab(5)='  q99.5 '
      Pklab(6)='  q99   '
      Pklab(7)='  q98   '
      Pklab(8)='  q95   '
      Pklab(9)='  q90   '
      Pklab(10)='  q80   '
      Pklab(11)='  q70   '
      Pklab(12)='  q60   '
      Pklab(13)='  q50   '
      Pklab(14)='  q40   '
      Pklab(15)='  q30   '
      Pklab(16)='  q20   '
      Pklab(17)='  q10   '
      Zlab(1)='CONSTANT'
      Zlab(2)='log(DA)'
      Zlab(3)='log(GF-30)'
      Zlab(4)='log(SF)'
      PRINT *, '======================================================', 
     &'==========='
      PRINT *, '     '
c
c     Set specifications for West region-of-influence
c
      IF(jreg.eq.1)then
c     logDA
      sd(1)=0.348
c      sd(1)=0.678
c     logGF
      sd(2)=0.2
c      sd(2)=0.284
c     logCF
      sd(3)=0.01
c      sd(3)=0.006
      Nsites=45
      END if
c
c     Set specifications for Central+East region-of-influence
c
      IF(jreg.eq.0)then
c     logDA
      sd(1)=0.32
c      sd(1)=0.680
c     logGF
      sd(2)=0.12
c      sd(2)=0.237
c     logCF
      sd(3)=0.008
c      sd(3)=0.017
      Nsites=45
      END if
c     Compute zero-flow probabilities
c
      probz7=exp(-5.73545+1.52553*logda+3.42930*loggf)
      probz7=1.0/(1.0+probz7)
      probz30=exp(-6.34833+1.56109*logda+4.46114*loggf)
      probz30=1.0/(1.0+probz30)
      probzd=exp(-0.737052+1.53054*logda+1.64762*loggf)
      probzd=1.0/(1.0+probzd)
c
c     Read in estimation data
c
      nest=0
      do 1 i=1,1100
        read(10,200,end=99)id(i),v(i,1),v(i,2),v(i,3), 
     +  v(i,4),v(i,5),v(i,6),(q(i,j),j=1,17),(jvar(i,j),j=1,17),
     +  ireg(i)
  200   format(2x,i8,4f12.5,2f11.5,/,17f10.5,/,
     +  17i4,/,i4)
        nest=nest+1
c     GEOLOGY FACTOR
        v(i,2)=alog10(v(i,2))
c     CLIMATE FACTOR
        v(i,3)=alog10(v(i,3))
c     SOIL FACTOR
        v(i,4)=alog10(v(i,4))
        read(11,201)name(i)
  201   format(a80) 
    1 continue
   99 continue 
      ncnt=nest
c
      WRITE(*,1203) 
      write(16,1203) 
 1203 FORMAT( ' Low-Flow and Flow-Duration computer program,',
     &' TDEC Version 3.0.1',/)
c
      IF(jreg.eq.0)then
      WRITE(*,1304)site,ltd,ltm,lts,lnd,lnm,lns,area,gf,cf,sf,uss
 1304 format(' Streamflow estimates for:',//,' 'a80,/, 
     &' LAT:',3i3,' LNG:',3i3,'  Central+East Tennessee Region',//,
     &' Explanatory variables:',//,
     &' DA:',f8.2,' GF:',f5.1,' CF:',f8.5,' SF:',f5.1,' SP:',f5.2)
      write(16,1204)site,ltd,ltm,lts,lnd,lnm,lns,area,gf,cf,sf,uss
 1204 format(' Streamflow estimates for:',//,' 'a80,//, 
     &' LAT:',3i3,' LNG:',3i3,'  Central+East Tennessee Region',//,
     &' Explanatory variables:',//,
     &' DA:',f8.2,' GF:',f5.1,' CF:',f8.5,' SF:',f5.1,' SP:',f5.2,//,
     &' Method specifications:',//,
     &' Number of sites in region-of-influence (ROI)= 45 [VARIABLE]',/,
     &' ROI selection metric = f(DA,GF,CF)',/,
     &' ROI regression = f(DA,GF-30,SF)',/,
     &' Number of sites in regional-regression (RRE)= 891 [CONSTANT]',/,
     &' RRE regression = f(DA,GF-30,CF,SF,SP)',/,)
      END if
c
      IF(jreg.eq.1)then
      WRITE(*,1308)site,ltd,ltm,lts,lnd,lnm,lns,area,gf,cf,sf,uss
 1308 format(' Streamflow estimates for:',//,' 'a80,/,
     &' LAT:',3i3,' LNG:',3i3,'  West Tennessee Region',//,
     &' Explanatory variables:',//,
     &' DA:',f8.2,' GF:',f5.1,' CF:',f8.5,' SF:',f5.1,' SP:',f5.2)
      write(16,1208)site,ltd,ltm,lts,lnd,lnm,lns,area,gf,cf,sf,uss
 1208 format(' Streamflow estimates for:',//,' 'a80,//,
     &' LAT:',3i3,' LNG:',3i3,'  West Tennessee Region',//,
     &' Explanatory variables:',//,
     &' DA:',f8.2,' GF:',f5.1,' CF:',f8.5,' SF:',f5.1,' SP:',f5.2,//,
     &' Method specifications:',//,
     &' Number of sites in region-of-influence (ROI)= 45 [VARIABLE]',/,
     &' ROI selection metric = f(DA,GF,CF)',/,
     &' ROI regression = f(DA,GF-30,SF)',/,
     &' Number of sites in regional-regression (RRE)= 124 [CONSTANT]',/,
     &' RRE regression = f(DA,GF-30,CF,SF,SP)',/,)
      END if
      WRITE(16,1209)
 1209 FORMAT( 'Region-of-influence stations and data:')
      WRITE(16,1406)
      write(16,1205) 
 1205 format( 'MNO    STANO     LAT    LNG     DA   GF  CF    SF',
     &' SP        LOCATION')
      WRITE(16,1406) 
 1406 FORMAT( '-------------------------------------------------------', 
     &'-------------------------')
c 
c     Compute distances
c
        do 3 i=1,nest
         sumd=((logda-v(i,1))/sd(1))**2
     &  +((loggf-v(i,2))/sd(2))**2
     &  +((logcf-v(i,3))/sd(3))**2
        dist(i)=sqrt(sumd)
    3   continue
c
c     Rank distances
c 
        call indexx(nest,dist,indx) 
c 
c     Select closest nsites stations for regression
c     loop through dependent variables and do regression
c
      write(16,1206)(name(indx(i)),i=1,nsites) 
 1206 format(a80)
      write(16,1406)
      write(16,1408) 
 1408 FORMAT(/, 'Low-Flow and Flow-Duration computer',
     &' program, TDEC Version 3.0.1',/)
      write(16,1404)site,ltd,ltm,lts,lnd,lnm,lns
 1404 format( ' Streamflow estimates for:',//,' 'a80,//, 
     &' LAT:',3i3,' LNG:',3i3,//,' Probability of:',/)
      WRITE (16,1560)probz7
 1560 FORMAT('     7Q10 of zero, p = ',f10.6,' (test for ',
     &'adjustment if p > 0.100)')
      WRITE (16,1561)probz30
 1561 FORMAT('     30Q5 of zero, p = ',f10.6,' (test for ',
     &'adjustment if p > 0.200)')
      WRITE (16,1562)probzd
 1562 FORMAT(' Duration of zero, p = ',f10.6,' (test for ',
     &'adjustment if p > 0.005)')
      WRITE(*,1211)
      write(16,1207)
 1207 format(/, ' Summary of regression results in cubic ft/s,',/,
     &' N = not adjusted; Y = adjusted for probability of zero:')
 1211 format(/, ' Summary of regression results in cubic ft/s,',/,
     &' N = not adjusted; Y = adjusted for probability of zero:',/)
      WRITE(16,1405)
      WRITE(*,1410)
      WRITE(16,1410)
 1410 FORMAT('  Rv         ROI VALUE      90% PREDICTION INTERVAL',
     & '     EY_ROI    RRE VALUE')
      WRITE(16,1405)
      DO 2 jpeak = 1, 17
c
c     Set starting explanatory variables to da, gf30, sf
c
      ne=4
c
      sums=0.0
      DO 700 i = 1, Nsites
        xv(i,1)=1.0
        xvt(1,i)=1.0
        xv(i,2)=v(indx(i),1)    
        xvt(2,i)=xv(i,2)
        gfc=10**v(indx(i),2)
        xv(i,3)=alog10(gfc-30.)
        xvt(3,i)=xv(i,3)
        xv(i,4)=v(indx(i),4)
        xvt(4,i)=xv(i,4)
        yv(i,1)=q(indx(i),jpeak)
        IF(jpeak.eq.1)sums=sums+v(indx(i),5)
        IF(jpeak.eq.2)sums=sums+v(indx(i),6)
  700 continue
      xo(1,1)=1.0
      xo(2,1)=logda
      xo(3,1)=lgf30
      xo(4,1)=logsf
      xot(1,1)=xo(1,1)
      xot(1,2)=xo(2,1)
      xot(1,3)=xo(3,1)
      xot(1,4)=xo(4,1)   
      xL=float(nsites)
      IF(jpeak.le.2)asig2=(sums/xL)**2
      CALL MLTPLY(xtx,xvt,xv,ne,nsites,ne,10,10,50)
      CALL INVERT(ne,10,det,xtxinv,xtx)
      CALL MLTPLY(work,xtxinv,xvt,ne,ne,nsites,10,10,10)
      CALL MLTPLY(bhat,work,yv,ne,nsites,1,10,10,50)
      CALL MLTPLY(e,xv,bhat,nsites,ne,1,50,50,10)
      sumsq=0.0
      do 721 k=1,nsites
        sumsq=sumsq+(yv(k,1)-e(k,1))**2
  721 continue
      df=nsites-ne
      CALL MLTPLY(work2,xot,xtxinv,1,ne,ne,1,1,10)
      CALL MLTPLY(hat,work2,xo,1,ne,1,1,1,10)
      se=sqrt(sumsq/df)
      seb=sqrt(1.0+hat(1,1))
      sep=se*seb
      tstat=1.680*sep
c
c     Output final regression step
c
      ndf=df
      pmax=0.00
      do 833 k=2,ne
        sesav(k,jpeak)=se*sqrt(xtxinv(k,k))
        tbeta(k,jpeak)=bhat(k,1)/sesav(k,jpeak)
        tv4=ABS(tbeta(k,jpeak))
        pv4(k,jpeak) = 2.0*STUTP(-tv4,ndf)
        if(pv4(k,jpeak).LT..0001) pv4(k,jpeak)=.0001
        bsav(1,jpeak)=bhat(1,1)
        sesav(1,jpeak)=se*SQRT(xtxinv(1,1))
        tbeta(1,jpeak)=bhat(1,1)/sesav(1,jpeak)
        tv4=ABS(tbeta(1,jpeak))
        pv4(1,jpeak) = 2.0*STUTP(-tv4,ndf)
        if(pv4(1,jpeak).LT..0001) pv4(1,jpeak)=.0001
        bsav(k,jpeak)=bhat(k,1)
  833 continue
      nexp(jpeak)=ne-1
      pru=bhat(1,1)+bhat(2,1)*xot(1,2)+bhat(3,1)*xot(1,3)
     & +bhat(4,1)*xot(1,4)
      cu90=10**(tstat+pru)
      cL90=10**(-tstat+pru)
      pred=10**pru
c     Regional-regression equations (2 regions: W Tenn, C&E Tenn)
c     7Q10 regional-regression eqn.
      if(jpeak.eq.1)then
        ey=(asig2*1.8211)/(sep**2)
        bing=-2.50170-4.00730*jreg
     &      +(1.03600+0.11300*jreg)*logda
     &      +(1.06600-0.47100*jreg)*lgf30
     &      +(0.27400-0.27400*jreg)*loguss
     &      +(0.27600+1.90400*jreg)*logSf
     &      -(2.67000-2.67000*jreg)*logcf
      end if
c     30Q5 regional-regression eqn.
      if(jpeak.eq.2)then
        ey=(asig2*1.3542)/(sep**2)
        bing=-1.97550-3.10750*jreg
     &      +(1.03100+0.07700*jreg)*logda
     &      +(0.87000-0.32700*jreg)*lgf30
     &      +(0.29900-0.29900*jreg)*loguss
     &      +(0.19500+1.37500*jreg)*logSf
     &      -(2.32000-2.32000*jreg)*logcf
      end if
c     MA regional-regression eqn.
      if(jpeak.eq.3)then
        IF(jreg.eq.1)then
        asig2=(1.0015-1.76*logcf-0.072*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.02202-0.0457*loggf+0.561*logcf)**2
        END if
        ey=asig2/(sep**2)
        bing=-0.77330-0.18817*jreg
     &      +(1.01420-0.00900*jreg)*logda
     &      +(0.00000+0.02330*jreg)*lgf30
     &      +(0.00000+0.15600*jreg)*logsf
     &      +(2.54000-0.50000*jreg)*logcf
     &      +(0.16500-0.16500*jreg)*loguss
      end if
c     MS regional-regression eqn.
      if(jpeak.eq.4)then
        IF(jreg.eq.1)then
        asig2=(1.5387-2.50*logcf-0.156*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.6005-0.272*loggf+0.530*logcf
     &        -0.0111*logda)**2
        END if
        ey=asig2/(sep**2)
        bing=0.142000-2.14370*jreg
     &      +(1.04480+0.01520*jreg)*logda
     &      +(0.21200-0.09900*jreg)*lgf30
     &      +(0.23200-0.23200*jreg)*loguss
     &      -(2.14000-2.14000*jreg)*logcf
     &      +(0.00000+0.78000*jreg)*logSf
      end if
c     D99.5 regional-regression eqn.
       if(jpeak.eq.5)then
        IF(jreg.eq.1)then
        asig2=(0.7030-0.056*logda-0.194*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.6154-0.0156*logda-0.211*loggf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-2.62000-3.90900*jreg
     &      +(1.03600+0.11600*jreg)*logda
     &      +(1.04900-0.45400*jreg)*lgf30
     &      +(0.27800-0.27800*jreg)*loguss
     &      +(0.26600+1.90400*jreg)*logSf
     &      -(2.26000-2.26000*jreg)*logcf
      end if
c     D99 regional-regression eqn.
       if(jpeak.eq.6)then
        IF(jreg.eq.1)then
        asig2=(0.5983-0.206*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.5580-0.201*loggf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-2.30880-3.59120*jreg
     &      +(1.03600+0.09800*jreg)*logda
     &      +(0.98000-0.40900*jreg)*lgf30
     &      +(0.25600-0.25600*jreg)*loguss
     &      +(0.22400+1.67600*jreg)*logSf
     &      -(2.42000-2.42000*jreg)*logcf
      end if
c     D98 regional-regression eqn.
       if(jpeak.eq.7)then
        IF(jreg.eq.1)then
        asig2=(0.5958-0.206*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.5502-0.198*loggf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-2.13830-3.29470*jreg
     &      +(1.03500+0.08500*jreg)*logda
     &      +(0.91800-0.36200*jreg)*lgf30
     &      +(0.26600-0.26600*jreg)*loguss
     &      +(0.21300+1.48700*jreg)*logSf
     &      -(2.36000-2.36000*jreg)*logcf
      end if
c     D95 regional-regression eqn.
       if(jpeak.eq.8)then
        IF(jreg.eq.1)then
        asig2=(0.5626-0.191*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.5619-0.205*loggf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-1.87050-3.08850*jreg
     &      +(1.04000+0.06400*jreg)*logda
     &      +(0.82900-0.28200*jreg)*lgf30
     &      +(0.30300-0.30300*jreg)*loguss
     &      -(2.23000-2.23000*jreg)*logcf
     &      +(0.16600+1.34400*jreg)*logSf
      end if
c     D90 regional-regression eqn.
       if(jpeak.eq.9)then
        IF(jreg.eq.1)then
        asig2=(0.5360-0.179*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.5760-0.210*loggf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-1.60840-2.91780*jreg
     &      +(1.04500+0.04800*jreg)*logda
     &      +(0.72700-0.18800*jreg)*lgf30
     &      +(0.33900-0.33900*jreg)*loguss
     &      -(2.05000-2.05000*jreg)*logcf
     &      +(0.13000+1.20000*jreg)*logSf
      end if
c     D80 regional-regression eqn.
       if(jpeak.eq.10)then
        IF(jreg.eq.1)then
        asig2=(0.4741-0.151*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.5891-0.213*loggf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-0.96440-3.09810*jreg
     &      +(1.05100+0.03700*jreg)*logda
     &      +(0.58100-0.07400*jreg)*lgf30
     &      +(0.00000+1.18000*jreg)*logSf
     &      -(2.12000-2.12000*jreg)*logcf
     &      +(0.33600-0.33600*jreg)*loguss
      end if
c     D70 regional-regression eqn.
       if(jpeak.eq.11)then
        IF(jreg.eq.1)then
        asig2=(0.4410-0.134*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.5847-0.209*loggf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-0.62030-2.82470*jreg
     &      +(1.05300+0.02500*jreg)*logda
     &      +(0.44200+0.04600*jreg)*lgf30
     &      +(0.00000+0.93000*jreg)*logSf
     &      -(2.04000-2.04000*jreg)*logcf
     &      +(0.33100-0.33100*jreg)*loguss
      end if
c     D60 regional-regression eqn.
       if(jpeak.eq.12)then
        IF(jreg.eq.1)then
        asig2=(0.4352-0.128*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.4526-0.202*loggf+0.340*logcf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-0.36680-4.04320*jreg
     &      +(1.05100+0.03600*jreg)*logda
     &      +(0.31900+0.07200*jreg)*lgf30
     &      +(0.31400+0.59600*jreg)*loguss
     &      -(1.76000-8.96000*jreg)*logcf
      end if
c     D50 regional-regression eqn.
       if(jpeak.eq.13)then
        IF(jreg.eq.1)then
        asig2=(0.4270-0.119*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.3248-0.1671*loggf+0.480*logcf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-0.26260-1.15740*jreg
     &      +(1.04770+0.02630*jreg)*logda
     &      +(0.21100+0.13800*jreg)*lgf30
     &      +(0.28200+0.50800*jreg)*loguss
     &      -(1.08000-1.08000*jreg)*logcf
      end if
c     D40 regional-regression eqn.
       if(jpeak.eq.14)then
        IF(jreg.eq.1)then
        asig2=(0.4173-0.110*loggf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.1683-0.1131*loggf+0.580*logcf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-0.33406-3.31594*jreg
     &      +(1.03940+0.02460*jreg)*logda
     &      +(0.12300+0.15200*jreg)*lgf30
     &      +(0.27200+0.34800*jreg)*loguss
     &      +(0.00000+6.80000*jreg)*logcf
      end if
c     D30 regional-regression eqn.
       if(jpeak.eq.15)then
        IF(jreg.eq.1)then
        asig2=(0.3068-0.097*loggf+0.040*logda)**2
        END if
        IF(jreg.eq.0)then
        asig2=(0.03524-0.0818*loggf+0.750*logcf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-0.30312-3.20758*jreg
     &      +(1.02740+0.00360*jreg)*logda
     &      +(0.06710+0.17990*jreg)*lgf30
     &      +(0.86000+6.84000*jreg)*logcf
     &      +(0.24300-0.24300*jreg)*loguss
     &      -(0.03900-0.03900*jreg)*logsf
      end if
c     D20 regional-regression eqn.
       if(jpeak.eq.16)then
        IF(jreg.eq.1)then
        asig2=(1.3412-0.063*loggf+0.038*logda
     &        -2.90*logcf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(-0.01776-0.0610*loggf+0.770*logcf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-0.13890-2.39110*jreg
     &      +(1.01450+0.01250*jreg)*logda
     &      +(0.00000+0.09200*jreg)*lgf30
     &      +(0.20600-0.20600*jreg)*loguss
     &      +(1.29000+5.31000*jreg)*logcf
     &      -(0.04800-0.04800*jreg)*logSf
      end if
c     D10 regional-regression eqn.
       if(jpeak.eq.17)then
        IF(jreg.eq.1)then
        asig2=(2.061-4.80*logcf)**2
        END if
        IF(jreg.eq.0)then
        asig2=(-0.03997-0.0485*loggf+0.770*logcf)**2
        END if
        ey=(1.57076*asig2)/(sep**2)
        bing=-0.06242+0.38902*jreg
     &      +(1.01310+0.02090*jreg)*logda
     &      +(1.96000-1.96000*jreg)*logcf
     &      +(0.14100-0.14100*jreg)*loguss
     &      -(0.03640-0.09040*jreg)*lgf30
     &      -(0.06100-0.06100*jreg)*logSf
      end if
      bing=10**bing
      p7meth=0
      p30meth=0
      pdmeth=0
 1400 format(a8,f11.2,a2,3x,5f12.2)
      IF(area.ge.2.5.and.gf.ge.60)then
      PRINT*,'No Adjustment Testing'
      WRITE(*,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      WRITE(16,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      GOTO 2
      END if
      IF(jreg.eq.1.and.area.ge.50.and.gf.ge.40)then
      PRINT*,'No Adjustment Testing'
      WRITE(*,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      WRITE(16,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      GOTO 2
      END if
      IF(jreg.eq.0.and.area.ge.100.and.gf.ge.40)then
      PRINT*,'No Adjustment Testing'
      WRITE(*,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      WRITE(16,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      GOTO 2
      END if
c
c     Logistic zero-flow testing
      if(jpeak.eq.1)then
c     Zero-flow-7Q10 adjustment West region
      IF(jreg.eq.1.and.area.lt.50.and.gf.lt.40.or.
     &   jreg.eq.1.and.area.lt.2.5.and.gf.lt.60)then
          if(probz7.ge.0.10)then
            p7meth=1
            predz7=0.00
            cL90z7=0.00
            bingz=0.00
              IF(area.ge.40)then
                predz7=((area-40)/10)*pred
                bingz=((area-40)/10)*bing
              END if
          END if
      END if
c     Zero-flow-7Q10 adjustment Central+East region
      IF(jreg.eq.0.and.area.lt.100.and.gf.lt.40.or.
     &   jreg.eq.0.and.area.lt.2.5.and.gf.lt.60)then
          if(probz7.ge.0.10)then
            p7meth=1
            predz7=0.00
            cL90z7=0.00
            bingz=0.00
              IF(area.ge.80)then
                predz7=((area-80)/20)*pred
                bingz=((area-80)/20)*bing
              END if
          END if
      END if
      END if
c
      if(jpeak.eq.2)then
c     Zero-flow-30Q5 adjustment equation West region
      IF(jreg.eq.1.and.area.lt.50.and.gf.lt.40.or.
     &   jreg.eq.1.and.area.lt.2.5.and.gf.lt.60)then
          IF(probz30.ge.0.200)then
            p30meth=1
            predz30=0.00
            cL90z30=0.00
            bingz=0.00
              IF(area.ge.40)then
                predz30=((area-40)/10)*pred
                bingz=((area-40)/10)*bing
              END if
          END if
      END if
c     Zero-flow-30Q5 adjustment Central+East region
      IF(jreg.eq.0.and.area.lt.100.and.gf.lt.40.or.
     &   jreg.eq.0.and.area.lt.2.5.and.gf.lt.60)then
          IF(probz30.ge.0.200)then
            p30meth=1
            predz30=0.00
            cL90z30=0.00
            bingz=0.00
              IF(area.ge.80)then
                predz30=((area-80)/20)*pred
                bingz=((area-80)/20)*bing
              END if
          END if
      END if
      END if
c     Zero-flow-duration adjustment West region
      IF(jreg.eq.1.and.area.lt.50.and.gf.lt.40.or.
     &   jreg.eq.1.and.area.lt.2.5.and.gf.lt.60)then
c     D99.5
      if(jpeak.eq.5)then
        IF(probzd.ge.0.005)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D99
      if(jpeak.eq.6)then
        IF(probzd.ge.0.01)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D98
      if(jpeak.eq.7)then
        IF(probzd.ge.0.02)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D95
      if(jpeak.eq.8)then
        IF(probzd.ge.0.05)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D90
      if(jpeak.eq.9)then
        IF(probzd.ge.0.10)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D80
      if(jpeak.eq.10)then
        IF(probzd.ge.0.20)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D70
      if(jpeak.eq.11)then
        IF(probzd.ge.0.30)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D60
      if(jpeak.eq.12)then
        IF(probzd.ge.0.40)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D50
      if(jpeak.eq.13)then
        IF(probzd.ge.0.50)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D40
      if(jpeak.eq.14)then
        IF(probzd.ge.0.60)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D30
      if(jpeak.eq.15)then
        IF(probzd.ge.0.70)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D20
      if(jpeak.eq.16)then
        IF(probzd.ge.0.80)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      END if
c     D10
      if(jpeak.eq.17)then
        IF(probzd.ge.0.90)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.40)then
              predzd=((area-40)/10)*pred
              bingz=((area-40)/10)*bing
            END if
        END if
      end if
      END if
c     Zero-flow-duration adjustment Central+East region
      IF(jreg.eq.0.and.area.lt.100.and.gf.lt.40.or.
     &   jreg.eq.0.and.area.lt.2.5.and.gf.lt.60)then
c     D99.5
      if(jpeak.eq.5)then
        IF(probzd.ge.0.005)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D99
      if(jpeak.eq.6)then
        IF(probzd.ge.0.01)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D98
      if(jpeak.eq.7)then
        IF(probzd.ge.0.02)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D95
      if(jpeak.eq.8)then
        IF(probzd.ge.0.05)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D90
      if(jpeak.eq.9)then
        IF(probzd.ge.0.10)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D80
      if(jpeak.eq.10)then
        IF(probzd.ge.0.20)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D70
      if(jpeak.eq.11)then
        IF(probzd.ge.0.30)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D60
      if(jpeak.eq.12)then
        IF(probzd.ge.0.40)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D50
      if(jpeak.eq.13)then
        IF(probzd.ge.0.50)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D40
      if(jpeak.eq.14)then
        IF(probzd.ge.0.60)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D30
      if(jpeak.eq.15)then
        IF(probzd.ge.0.70)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D20
      if(jpeak.eq.16)then
        IF(probzd.ge.0.80)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      END if
c     D10
      if(jpeak.eq.17)then
        IF(probzd.ge.0.90)then
          pdmeth=1
          predzd=0.00
          cL90zd=0.00
          bingz=0.00
            IF(area.ge.80)then
              predzd=((area-80)/20)*pred
              bingz=((area-80)/20)*bing
            END if
        END if
      end if
      END if
c     output 7Q10
      IF(jpeak.eq.1)then
      IF(p7meth.eq.0)then
      WRITE(*,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      WRITE(16,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      END if
      if(p7meth.eq.1)then
      WRITE(*,1400)pklab(jpeak),predz7,alab(2),cL90z7,cu90,ey,bingz
      WRITE(16,1400)pklab(jpeak),predz7,alab(2),cL90z7,cu90,ey,bingz
      END if
      END if
c     output 30Q5
      IF(jpeak.eq.2)then
      IF(p30meth.eq.0)then
      WRITE(*,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      WRITE(16,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      END if
      IF(p30meth.eq.1)then
      WRITE(*,1400)pklab(jpeak),predz30,alab(2),cL90z30,cu90,ey,bingz
      WRITE(16,1400)pklab(jpeak),predz30,alab(2),cL90z30,cu90,ey,
     &bingz
      END if
      END if
c     output MA & MS
      IF(jpeak.eq.3.or.jpeak.eq.4)then
      WRITE(*,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      WRITE(16,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      END if
c     output D99.5 to D10
      IF(jpeak.ge.5)then
      IF(pdmeth.eq.0)then
      WRITE(*,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      WRITE(16,1400)pklab(jpeak),pred,alab(1),cL90,cu90,ey,bing
      END if
      IF(pdmeth.eq.1)then
      WRITE(*,1400)pklab(jpeak),predzd,alab(2),cL90zd,cu90,ey,bingz
      WRITE(16,1400)pklab(jpeak),predzd,alab(2),cL90zd,cu90,ey,bingz
      END if
      END if
    2 continue
c
      WRITE(16,1405) 
 1405 FORMAT( ' =====================================================', 
     &'========================')
      WRITE (16,1507)
 1507 FORMAT(//,'  ROI regression equations:')
      WRITE(16,1506)
 1506 FORMAT('  -------------------------------------------------',
     &'----------')
      WRITE (16,1505)
 1505 FORMAT('  Rv     PARAMETER   COEFFICIENT    SE     T:BETA=0',
     &'   P-VALUE')
      WRITE(16,1506)
      do 1013 kk=1,17
      WRITE(16,1420)pklab(kk),zlab(1),bsav(1,kk),sesav(1,kk),
     & tbeta(1,kk),pv4(1,kk)
 1420 FORMAT (a8,2x,a10,4f10.4)
      IF(nexp(kk).eq.3)then
      do 1012 jj=2,4
      WRITE(16,1421)zlab(jj),bsav(jj,kk),sesav(jj,kk),
     & tbeta(jj,kk),pv4(jj,kk)
 1012 continue
      END if
 1013 continue
 1421 FORMAT (10x,a10,4f10.4)
      WRITE(16,1506)
      PRINT *, '    '
      PRINT *, 'Results written to output file.' 
      PRINT *, '    '
      WRITE(16,1510)
 1510 FORMAT(/,' END PROGRAM')
      stop 
      end
c
c     INDEXX***INDEXX***INDEXX***INDEXX***INDEXX***INDEXX***INDEXX
c
c     Subroutine INDEXX indexs an array ARRIN of length N, outputs the
c     array INDX such that ARRIN(INDX(J)) is in ascending order for
c     J=1,2,..,N. The input quantities ARRIN and N are not changed
c     (ref. Numerical Recipes, p. 233)
c 
      SUBROUTINE INDEXX(N,ARRIN,INDX) 
      REAL ARRIN(1050), q 
      INTEGER i, INDX(1050), indxt, ir, j, l, N 
C 
      DO 100 j = 1, N 
        INDX(j) = j 
 100  CONTINUE 
      l = N/2 + 1 
      ir = N 
 200  CONTINUE 
      IF ( l.GT.1 ) THEN 
        l = l - 1 
        indxt = INDX(l) 
        q = ARRIN(indxt) 
      ELSE 
        indxt = INDX(ir) 
        q = ARRIN(indxt) 
        INDX(ir) = INDX(1) 
        ir = ir - 1 
        IF ( ir.EQ.1 ) THEN 
          INDX(1) = indxt 
          RETURN 
        ENDIF 
      ENDIF 
      i = l 
      j = l + l 
 300  CONTINUE 
      IF ( j.LE.ir ) THEN 
        IF ( j.LT.ir ) THEN 
          IF ( ARRIN(INDX(j)).LT.ARRIN(INDX(j+1)) ) j = j + 1 
        ENDIF 
        IF ( q.LT.ARRIN(INDX(j)) ) THEN 
          INDX(i) = INDX(j) 
          i = j 
          j = j + j 
        ELSE 
          j = ir + 1 
        ENDIF 
        GOTO 300 
      ENDIF 
      INDX(i) = indxt 
      GOTO 200 
      END 
c
c     STUTP***STUTP***STUTP***STUTP***STUTP***STUTP***STUTP
c
      FUNCTION STUTP(X,N)
      REAL a, b, GAUSCF, rhpi, STUTP, t, X, y, z
      INTEGER j, N, nn
C
C     STUDENT T PROBABILITY
C     STUTP = PROB( STUDENT T WITH N DEG FR  .LT.  X )
C
C     NOTE  -  PROB(ABS(T).GT.X) = 2.*STUTP(-X,N) (FOR X .GT. 0.)
C
C     SUBPGM USED - GAUSCF
C
C     REF - G.W. HILL, ACM ALGOR 395, OCTOBER 1970.
C
C     USGS - WK 12/79.
C
C
      DATA rhpi/.63661977/
C
      STUTP = .5
      IF (N.LT.1) RETURN
C
      nn = N
      z = 1.
      t = X**2
      y = t/nn
      b = 1.0 + y
C
      IF (.NOT.(nn.GE.20.AND.t.LT.nn.OR.nn.GT.200)) THEN
C              ( OR IF NN NON-INTEGER)
C
        IF (nn.LT.20 .AND. t.LT.4.) THEN
C
C  --  NESTED SUMMATION OF COSINE SERIES
          y = SQRT(y)
          a = y
          IF (nn.EQ.1) a = 0.
        ELSE
C
C  --  TAIL SERIES FOR LARGE T
          a = SQRT(b)
          y = a*nn
          j = 0
   10     j = j + 2
          IF (a.EQ.z) THEN
            nn = nn + 2
            z = 0.
            y = 0.
            a = -a
          ELSE
            z = a
            y = y*(j-1)/(b*j)
            a = a + y/(nn+j)
            GOTO 10
          ENDIF
        ENDIF
   20   nn = nn - 2
        IF (nn.LE.1) THEN
          IF (nn.EQ.0) a = a/SQRT(b)
          IF (nn.NE.0) a = (ATAN(y)+a/b)*rhpi
          STUTP = 0.5*(z-a)
          IF (X.GT.0.) STUTP = 1. - STUTP
          RETURN
        ELSE
          a = (nn-1)/(b*nn)*a + y
          GOTO 20
        ENDIF
      ENDIF
C
C  --  ASYMPTOTIC SERIES FOR LARGE OR NONINTEGER N
      IF (y.GT.1E-6) y = ALOG(b)
      a = nn - 0.5
      b = 48.*a**2
      y = a*y
      y = (((((-0.4*y-3.3)*y-24.)*y-85.5)/(0.8*y**2+100.+b)+y+3.)/b+1.)
     &    *SQRT(y)
      STUTP = GAUSCF(-y)
      IF (X.GT.0.) STUTP = 1. - STUTP
      RETURN
C
      END
C
C     GAUSEX***GAUSEX***GAUSEX***GAUSEX***GAUSEX***GAUSEX***GAUSEX
C
      FUNCTION GAUSEX(EXPROB)
      REAL ax, c0, c1, c2, CUMPRB, d, d1, d2, d3, EXPROB, GAUSEX, p, pr, 
     &     t, xlim, XX
C
C     GAUSSIAN PROBABILITY FUNCTIONS   W.KIRBY  JUNE 71
C          GAUSEX=VALUE EXCEEDED WITH PROB EXPROB
C          GAUSAB=VALUE (NOT EXCEEDED) WITH PROBCUMPROB
C          GAUSCF=CUMULATIVE PROBABILITY FUNCTION
C          GAUSDY=DENSITY FUNCTION
C     SUBPGMS USED -- NONE
C
C     GAUSCF MODIFIED 740906 WK -- REPLACED ERF FCN REF BY RATIONAL APPRX N
C     ALSO REMOVED DOUBLE PRECISION FROM GAUSEX AND GAUSAB.
C     76-05-04 WK -- TRAP UNDERFLOWS IN EXP IN GUASCF AND DY.
C
C
      DATA xlim/18.3/
      DATA c0, c1, c2/2.51551700, .8028530000, .0103280000/
      DATA d1, d2, d3/1.432788000, .1892690000, .0013080000/
C
      p = EXPROB
   10 IF (p.GE.1.0) THEN
        GAUSEX = -10.
      ELSEIF (p.GT.0.) THEN
        pr = p
        IF (p.GT..5) pr = 1.00 - pr
        t = SQRT(-2.00*ALOG(pr))
        GAUSEX = t - (c0+t*(c1+t*c2))/(1.0+t*(d1+t*(d2+t*d3)))
        IF (p.GT..5) GAUSEX = -GAUSEX
      ELSE
        GAUSEX = +10.
      ENDIF
      RETURN
C
      ENTRY GAUSAB(CUMPRB)
      GAUSAB = 0.
      p = 1. - CUMPRB
      GOTO 10
C
      ENTRY GAUSCF(XX)
      ax = ABS(XX)
      GAUSCF = 1.
      IF (ax.LE.xlim) THEN
        t = 1.0/(1.0+.2316419*ax)
        d = 0.3989423*EXP(-XX*XX*.5)
        GAUSCF = 1. - 
     &           d*t*((((1.330274*t-1.821256)*t+1.781478)*t-0.3565638)
     &           *t+0.3193815)
      ENDIF
      IF (XX.LT.0) GAUSCF = 1. - GAUSCF
      RETURN
C
      ENTRY GAUSDY(XX)
      GAUSDY = 0.
      IF (ABS(XX).GT.xlim) RETURN
      GAUSDY = .3989423*EXP(-.500*XX*XX)
      RETURN
      END
c
c     MLTPLY***MLTPLY***MLTPLY***MLTPLY***MLTPLY***MLTPLY***MLTPLY
c
      SUBROUTINE MLTPLY(PROD,X,Y,K1,K2,K3,N1,N2,N3)
      INTEGER i, j, k, K1, K2, K3, N1, N2, N3
      REAL PROD(N1,K3), X(N2,K2), Y(N3,K3), summ
c
c     ----------------------------------------------------------
c     X IS K1*K2 MATRIX.
c     Y IS K2*K3 MATRIX.
c     PROD = X*Y IS A K1*K3 MATRIX.
c     ----------------------------------------------------------
c
      DO 30 i = 1, K1
        DO 20 k = 1, K3
          summ = 0.
          DO 10 j = 1, K2
            summ = summ + X(i,j)*Y(j,k)
   10     CONTINUE
          PROD(i,k) = summ
   20   CONTINUE
   30 CONTINUE
      RETURN
      END
c
c     INVERT***INVERT***INVERT***INVERT***INVERT***INVERT***INVERT
c
      SUBROUTINE INVERT(N,NDIM,DET,COVINV,COV)
      INTEGER i, im, j, k, N, NDIM
      REAL DET, detl, sumi, temp, COVINV(NDIM,NDIM), COV(NDIM,NDIM),
     &     b(50,50), a(50,50)
c
c     --------------------------------------------------------------
c     COV IS AN N*N MATRIX.
c     SUBROUTINE COMPUTES DETERMINANT OF COV THEN REPLACES COV
c       WITH ITS INVERSE.
c     B IS THE LOWER TRIANGULAR DECOMPOSITION OF COV.
c     --------------------------------------------------------------
c
      IF (N.EQ.2) THEN
        DET = COV(1,1)*COV(2,2) - COV(1,2)**2
        temp = COV(1,1)/DET
        COVINV(1,1) = COV(2,2)/DET
        COVINV(2,2) = temp
        COVINV(1,2) = -COV(1,2)/DET
        COVINV(2,1) = COVINV(1,2)
      ELSE
        CALL DECOMP(N,NDIM,COV,b)
        detl = b(1,1)
        DO 10 i = 2, N
          detl = detl*b(i,i)
   10   CONTINUE
        DET = detl**2
        a(1,1) = 1./b(1,1)
        a(2,2) = 1./b(2,2)
        a(2,1) = -b(2,1)*a(1,1)*a(2,2)
        DO 40 i = 3, N
          a(i,i) = 1./b(i,i)
          im = i - 1
          DO 30 k = 1, im
            sumi = 0.
            DO 20 j = k, im
              sumi = sumi + b(i,j)*a(j,k)
   20       CONTINUE
            a(i,k) = -sumi*a(i,i)
   30     CONTINUE
   40   CONTINUE
        DO 70 i = 1, N
          DO 60 j = 1, i
            sumi = 0.
            DO 50 k = i, N
              sumi = sumi + a(k,i)*a(k,j)
   50       CONTINUE
            COVINV(i,j) = sumi
            COVINV(j,i) = sumi
   60     CONTINUE
   70   CONTINUE
      ENDIF
      RETURN
 9005 FORMAT (1X,' PROCESSING STOPPED -- SINGULAR MATRIX')
      END
c
c     DECOMP***DECOMP***DECOMP***DECOMP***DECOMP***DECOMP***DECOMP
c
      SUBROUTINE DECOMP(N,NDIM,XLAM,B)
      INTEGER is, ism, js, jsm, ks, N, NDIM
      REAL XLAM(NDIM,NDIM), B(50,50), bh, bn
c
c     --------------------------------------------------------------
c     CHOLESKY DECOMPOSITION  BB-TRANSPOSE = XLAM
c     --------------------------------------------------------------
c
      IF (XLAM(1,1).LE.0. .OR. XLAM(2,2).LE.0.) WRITE (*,9005) N, NDIM, 
     &    XLAM(1,1), XLAM(2,1), XLAM(2,2), XLAM(1,2)
      B(1,1) = SQRT(XLAM(1,1))
      B(1,2) = 0.
      B(2,1) = XLAM(2,1)/B(1,1)
      B(2,2) = SQRT(XLAM(2,2)-B(2,1)**2)
      IF (N.LE.2) RETURN
      DO 30 is = 3, N
        B(is,1) = XLAM(is,1)/B(1,1)
        bn = XLAM(is,is) - B(is,1)**2
        ism = is - 1
        DO 20 js = 2, ism
          jsm = js - 1
          bh = XLAM(is,js)
          DO 10 ks = 1, jsm
            bh = bh - B(is,ks)*B(js,ks)
   10     CONTINUE
          B(is,js) = bh/B(js,js)
          bn = bn - B(is,js)**2
   20   CONTINUE
        IF (bn.LE.0.) WRITE (1,9010) bn
        B(is,is) = SQRT(AMAX1(bn,0.00))
   30 CONTINUE
      RETURN
 9005 FORMAT (' IN DECOMP/ N, NDIM,XLAM 1-1,2-1,2-2,1-2 = ',2I5,/,
     &        4G13.4,/,' COVARIANCE MATRIX NOT POSITIVE DEFINITE')
 9010 FORMAT (1X,' COVARIANCE MATRIX NOT POSITIVE DEFINITE BN=',F10.3)
      END
